{

DBVersion - Checks DB engines installed in the System

Author : Tejasvi Hegde, Calibre Technologies
email  : tejasvi@calibretechnologies.com 
Date   : 10-Feb-2001
version: 1.0

---------------------------------------------------------------------------
Version Info and variables set according to DB engines intalled at run time
---------------------------------------------------------------------------

Thanks to Writer of DFS for his great components
one of which, TdfsVersionInfoResource Reduced lots
of work.

Thanks Writer of DSCheckBox at DigitStudios,
for his nice colored check mark glyphs,
which I used in Engines List View

Note: You need to install TdfsVersionInfoResource
component (which comes with DFS components)  to
compile this code.

}

unit DBVersion;

interface
uses
  Windows, Messages, SysUtils, Classes, VersInfo ;

// These variables are filled at run time in initialization time.
// You can access all version info from these Version Info Variables
var
        DAOLIB_Verson : TdfsVersionInfoResource;
        DAO35_Verson  : TdfsVersionInfoResource;
        DAO36_Verson  : TdfsVersionInfoResource;
        ADO_Verson    : TdfsVersionInfoResource;

        isDAO         : Boolean = False;
        isDAO35       : Boolean = False;
        isDAO36       : Boolean = False;
        isADO         : Boolean = False;
        isADOBELOW25  : Boolean = False;
        isADO25       : Boolean = False;
        isADO26       : Boolean = False;

implementation
uses registry;

Procedure GetDATAVer ;
var
 Reg   : TRegistry;
 DB_Engine_CLS,DAO_35_CLS,DAO_36_CLS : String;
 DB_Engine_FILE,DAO_35_FILE,DAO_36_FILE : String;
 ADO_CLS,ADO_CLS_ID, ADO_FILE      : String;
begin
 Reg  := TRegistry.Create;

 DB_Engine_CLS  := '\CLSID\{00025e15-0000-0000-c000-000000000046}\InprocServer';
 DAO_35_CLS     := '\CLSID\{00000010-0000-0010-8000-00AA006D2EA4}\InprocServer32';
 DAO_36_CLS     := '\CLSID\{00000100-0000-0010-8000-00AA006D2EA4}\InprocServer32';
 DB_Engine_FILE := '';
 DAO_35_FILE    := '';
 DAO_36_FILE    := '';


 ADO_CLS_ID     := '\ADODB.Connection\CLSID';
 ADO_CLS        := '';
 ADO_FILE       := '';

   Reg.RootKey := HKEY_CLASSES_ROOT;

// *** ADO

   Reg.OpenKey(ADO_CLS_ID, False);
   ADO_CLS := Reg.ReadString('');
   Reg.CloseKey;

   if Trim(ADO_CLS) <> '' then
   begin
        ADO_CLS := '\CLSID\'+ADO_CLS+'\InprocServer32';
        Reg.OpenKey(ADO_CLS, False);
        ADO_FILE := Reg.ReadString('');
        Reg.CloseKey;
   end;


   if Trim(ADO_FILE) <> '' then
   begin
       ADO_Verson := TdfsVersionInfoResource.Create(Nil);
       ADO_Verson.Filename := Trim(ADO_FILE);
   end;



// *** DAO
   Reg.OpenKey(DB_Engine_CLS, False);
   DB_Engine_FILE := Reg.ReadString('');
   Reg.CloseKey;

   if Trim(DB_Engine_FILE) = '' then
   begin
        DB_Engine_CLS  := '\CLSID\{00025e15-0000-0000-c000-000000000046}\InprocServer32';
        Reg.OpenKey(DB_Engine_CLS, False);
        DB_Engine_FILE := Reg.ReadString('');
        Reg.CloseKey;
   end;

   Reg.OpenKey(DAO_35_CLS, False);
   DAO_35_FILE := Reg.ReadString('');
   Reg.CloseKey;

   Reg.OpenKey(DAO_36_CLS, False);
   DAO_36_FILE := Reg.ReadString('');
   Reg.CloseKey;



   if Trim(DB_Engine_FILE) <> '' then
   begin
       DAOLIB_Verson := TdfsVersionInfoResource.Create(Nil);
       DAOLIB_Verson.Filename := Trim(DB_Engine_FILE);
   end;

   if Trim(DAO_35_FILE) <> '' then
   begin
       DAO35_Verson := TdfsVersionInfoResource.Create(Nil);
       DAO35_Verson.Filename := Trim(DAO_35_FILE);
   end;

   if Trim(DAO_36_FILE) <> '' then
   begin
      DAO36_Verson := TdfsVersionInfoResource.Create(Nil);
      DAO36_Verson.Filename := Trim(DAO_36_FILE);
   end;

   Reg.Free;
end;


initialization
  DAOLIB_Verson := Nil;
  DAO35_Verson  := Nil;
  DAO36_Verson  := Nil;
  ADO_Verson    := Nil;
  GetDATAVer;

  if ADO_Verson <> Nil then
  begin
          isADO         := True;
          isADOBELOW25  :=  ((ADO_Verson.FileVersion.Major <= 2) and (ADO_Verson.FileVersion.Minor < 50));
          isADO25       :=  ((ADO_Verson.FileVersion.Major = 2) and ((ADO_Verson.FileVersion.Minor >= 50) and (ADO_Verson.FileVersion.Minor < 60)));
          isADO26       := ((ADO_Verson.FileVersion.Major = 2) and (ADO_Verson.FileVersion.Minor >= 60));
  end;

  if DAOLIB_Verson <> Nil then
          isDAO         := True;

  if DAO35_Verson <> Nil then
          isDAO35       := ((DAO35_Verson.FileVersion.Major = 3) and ((DAO35_Verson.FileVersion.Minor >= 50) and  (DAO35_Verson.FileVersion.Minor < 60)));

  if DAO36_Verson <> Nil then
          isDAO36       := ((DAO36_Verson.FileVersion.Major = 3) and (DAO36_Verson.FileVersion.Minor >= 60));

  isDAO := isDAO or isDAO35 or isDAO36;

finalization
   if DAOLIB_Verson <> Nil then
        DAOLIB_Verson.Free;

   if DAO35_Verson <> Nil then
        DAO35_Verson.Free;

   if DAO36_Verson <> Nil then
        DAO36_Verson.Free;

   if ADO_Verson <> Nil then
        ADO_Verson.Free;
end.




